// def gitRepo = "https://gitlab.com/atmaji.tri/express-helloworld.git"

// def branch = env.branch

def registry = "trikerja.jfrog.io"
def registryOCP = "default-route-openshift-image-registry.apps.ocp.mii.lab"
def repoRegistry = "demo-muf-dev"
def repoRegistryProd = "demo-muf-prd"
def appName = "demo"
def apiOCP = "https://api.jmtc-ocp.jasamarga.co.id:6443"
def ocpProject = "jid-test"
def tag = env.tag
def isRelease = env.isRelease

pipeline {
    agent {
        label 'wsl2'
    }

    stages {
        stage('Build Image') {
            steps {
                script{
                    withCredentials([usernamePassword(credentialsId: 'jfrog-labtri', passwordVariable: 'passwordJfrog', usernameVariable: 'usernameJfrog')]) {
                        withCredentials([usernamePassword(credentialsId: 'ocp-labmii', passwordVariable: 'password', usernameVariable: 'username')]) {
                            sh"oc login -u ${username} -p ${password} ${apiOCP}"
                        }
                        sh"""
                            podman build -t ${registry}/${repoRegistry}/${appName}:${GIT_COMMIT} .
                            podman tag ${registry}/${repoRegistry}/${appName}:${GIT_COMMIT} ${registry}/${repoRegistry}/${appName}:latest
                            podman login -u ${usernameJfrog} -p ${passwordJfrog} ${registry} --tls-verify=false
                            podman push ${registry}/${repoRegistry}/${appName}:${GIT_COMMIT}
                            podman push ${registry}/${repoRegistry}/${appName}:latest
                        """
                        if(isRelease == "true"){
                            sh"""
                                podman tag ${registry}/${repoRegistry}/${appName}:${GIT_COMMIT} ${registry}/${repoRegistryProd}/${appName}:${GIT_COMMIT}
                                podman tag ${registry}/${repoRegistry}/${appName}:${GIT_COMMIT} ${registry}/${repoRegistryProd}/${appName}:latest
                                podman login -u ${usernameJfrog} -p ${passwordJfrog} ${registry} --tls-verify=false
                                podman push ${registry}/${repoRegistryProd}/${appName}:${GIT_COMMIT}
                                podman push ${registry}/${repoRegistryProd}/${appName}:latest
                            """
                        }
                    }
                    
                }
                echo 'Build Image Succes'
            }
        }
        stage('Deploy To OCP') {
            steps {
                script{
                    withCredentials([usernamePassword(credentialsId: 'ocp-labmii', passwordVariable: 'password', usernameVariable: 'username')]) {
                        sh"oc login -u ${username} -p ${password} ${apiOCP}"
                        try{
                            sh"oc delete deploy,dc,svc,routes ${appName}-dc"
                        }catch(Exception e){}
                        try{
                            sh"oc delete deploy,dc,svc,routes ${appName}-deploy"
                        }catch(Exception e){}
                        sh"""
                            oc project ${ocpProject}
                            oc new-app --image=${registry}/${repoRegistry}/${appName}:${GIT_COMMIT} --name=${appName}-dc --as-deployment-config
                            oc expose svc/${appName}-dc 
                            oc new-app --image=${registry}/${repoRegistry}/${appName}:${GIT_COMMIT} --name=${appName}-deploy
                            oc expose svc/${appName}-deploy
                        """
                    }
                }
                echo 'Build Image Succes'
            }
        }
    }
    post {
        always{
            cleanWs()
            script{
                try{
                    sh"podman system prune -af"
                }catch(Exception e){}
            }
            echo 'clean workspace success'
        }
    }
}
